<?php
defined( 'ABSPATH' ) or die( 'No script kiddies please!' );

class RML_Upload {
	private static $me = null;
        
    private function __construct() {
            
    }
    
    /**
     * The grid view and post editor upload can be modified through the left
     * tree view to upload files directly.
     * 
     * @hooked pre-upload-ui
     */
    public function pre_upload_ui() {
        global $pagenow;
        
        // Get the options depending on the current page
        if ($pagenow === "media-new.php") {
            $options = wp_rml_dropdown("-1", array(RML_TYPE_COLLECTION, RML_TYPE_ALL));
            $label = __("You can simply upload files directly to a folder. Select a folder and upload files.", RML_TD);
            $style = "display:block;";
        }else{
            $options = '<option selected="true" value="-1">' . __("Loading...", RML_TD) . '</option>';
            $label = __("upload to folder", RML_TD);
            $style = "display:none;";
        }
        
        echo '<p class="attachments-filter-upload-chooser" style="' . $style . '">' . $label . '<br/></p>
        <p style="' . $style . '">
            <select>' . $options . '</select>
        </p>';
    }
    
    public static function getInstance() {
        if (self::$me == null) {
                self::$me = new RML_Upload();
        }
        return self::$me;
    }
}

?>